<xsl:stylesheet version = '1.0' 
     xmlns:xsl='http://www.w3.org/1999/XSL/Transform'>

<xsl:output method = "xml" indent="yes"/>

<xsl:template match="/">
	<svg width="600" height="400">
	<xsl:apply-templates/>
	</svg>
</xsl:template>
	
<xsl:template match="//h1"> 
	<g>
	<text class ="heading">	
          <xsl:value-of select="."/>  
    </text>
    </g> 
</xsl:template>

<xsl:template match="//li"> 
	<g>
	<circle class="bullet" r="10" />
	<text class="bullet">	
          <xsl:value-of select="."/>
    </text>
    </g> 
</xsl:template>

<xsl:template match="/html/head/title"> 
          <xsl:copy-of select="."/>
          <desc>Generated using XSLT</desc>
</xsl:template>

</xsl:stylesheet>
