<xsl:stylesheet version = '1.0' 
     xmlns:xsl='http://www.w3.org/1999/XSL/Transform'>

<xsl:output method = "xml" indent = "yes" encoding="iso-8859-1" />

<xsl:template match="/">
	<html><head>
	<xsl:copy-of select="/root/title"/>
	</head>
	<body>
	<h1>
	<xsl:value-of select="/root/heading"/>
	</h1>
	<ul>
	<xsl:apply-templates/>
	</ul>
	</body></html>
</xsl:template>

<xsl:template match="//*[starts-with(name(), 'bullet')]"> 
	<li>
      <xsl:value-of select="."/>
     </li>     
</xsl:template>

<xsl:template match="text()">
</xsl:template>

</xsl:stylesheet>