<%@ Page Language="c#" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.OleDb" %>
<script runat="server">
int RunSQL(string sql) {
  OleDbConnection conn = new OleDbConnection(
    "Provider=Microsoft.Jet.OleDb.4.0; Data Source=c:\\inetpub\\db\\svg.mdb");
  conn.Open();
  OleDbCommand comm = new OleDbCommand(sql, conn);
  int ret = comm.ExecuteNonQuery();
  conn.Close();
  return ret;
}

void CreatePoll(Object o, EventArgs e) {
  OleDbConnection conn = new OleDbConnection(
    "Provider=Microsoft.Jet.OleDb.4.0; Data Source=c:\\inetpub\\db\\svg.mdb");
  conn.Open();
  OleDbCommand comm = new OleDbCommand("SELECT * FROM poll WHERE name='" + pollname.Text + "'", conn);
  OleDbDataReader reader = comm.ExecuteReader();
  if (reader.Read()) {
    message.Text = "Poll with name '" + pollname.Text + "' already exists!";
    reader.Close();
  } else {
    message.Text = "";
    reader.Close();
    OleDbCommand comm1 = new OleDbCommand("INSERT INTO poll (name) VALUES ('" + pollname.Text + "')", conn);
    comm1.ExecuteNonQuery();
    OleDbCommand comm2 = new OleDbCommand("SELECT id FROM poll WHERE name='" + pollname.Text + "'", conn);
    OleDbDataReader reader2 = comm2.ExecuteReader();
    reader2.Read();
    int id = (int)reader2["id"];
    reader2.Close();
    FillPollGrid();
    Session["pid"] = id;
    FillAltGrid();
  }
  reader.Close();
  conn.Close();
}

void FillPollGrid() {
  PollPanel.Visible = true;
  AltPanel.Visible = false;
  OleDbConnection conn = new OleDbConnection(
    "Provider=Microsoft.Jet.OleDb.4.0; Data Source=c:\\inetpub\\db\\svg.mdb");
  conn.Open();
  OleDbDataAdapter adapter = new OleDbDataAdapter("SELECT * FROM poll", conn);
  DataSet data = new DataSet();
  adapter.Fill(data, "poll");
  polls.DataSource = data.Tables["poll"].DefaultView;
  polls.DataBind();
  conn.Close();
}

void PollEdit(Object o, DataGridCommandEventArgs e) {
  polls.EditItemIndex = e.Item.ItemIndex;
  FillPollGrid();
}

void PollUpdate(Object o, DataGridCommandEventArgs e) {
  string sql = "UPDATE poll ";
  sql += "SET name='" + ((TextBox)e.Item.Cells[1].Controls[0]).Text + "' ";
  sql += "WHERE id=" + polls.DataKeys[e.Item.ItemIndex];
  RunSQL(sql);
  polls.EditItemIndex = -1;
  FillPollGrid();
}

void PollCancel(Object o, DataGridCommandEventArgs e) {
  polls.EditItemIndex = -1;
  FillPollGrid();
}

void PollCommand(Object o, DataGridCommandEventArgs e) {
  if (e.CommandName == "Toggle") {  
    string sql = "UPDATE poll SET status='inactive'";
    RunSQL(sql);
    sql = "UPDATE poll ";
    sql += "SET status='" + ((e.CommandArgument.ToString() == "active") ? "inactive" : "active") + "' ";
    sql += "WHERE id=" + polls.DataKeys[e.Item.ItemIndex];    
    RunSQL(sql);
    polls.EditItemIndex = -1;
    FillPollGrid();
  } else if (e.CommandName == "Alternatives") {
    Session["pid"] = Convert.ToInt32(e.CommandArgument.ToString());
    FillAltGrid();
  } else if (e.CommandName == "Delete") {
    string sql = "DELETE FROM poll ";
    sql += "WHERE id=" + polls.DataKeys[e.Item.ItemIndex];    
    RunSQL(sql);
    sql = "DELETE FROM alternative ";
    sql += "WHERE poll_id=" + polls.DataKeys[e.Item.ItemIndex];    
    RunSQL(sql);
    FillPollGrid();
  }
}

/* ---------------------------------------------------------------------------------- */

void CreateAlternative(Object o, EventArgs e) {
  OleDbConnection conn = new OleDbConnection(
    "Provider=Microsoft.Jet.OleDb.4.0; Data Source=c:\\inetpub\\db\\svg.mdb");
  conn.Open();
  OleDbCommand comm = new OleDbCommand("SELECT * FROM alternative WHERE name='" + altname.Text + "'", conn);
  OleDbDataReader reader = comm.ExecuteReader();
  if (reader.Read()) {
    message.Text = "Alternative with name '" + altname.Text + "' already exists!";
    reader.Close();
  } else {
    message.Text = "";
    reader.Close();
    OleDbCommand comm1 = new OleDbCommand("INSERT INTO alternative (name, poll_id) VALUES ('" + altname.Text + "', " + Session["pid"] + ")", conn);
    comm1.ExecuteNonQuery();
  }
  reader.Close();
  conn.Close();
  FillAltGrid();
}

void FillAltGrid() {
  PollPanel.Visible = false;
  AltPanel.Visible = true;
  OleDbConnection conn = new OleDbConnection(
    "Provider=Microsoft.Jet.OleDb.4.0; Data Source=c:\\inetpub\\db\\svg.mdb");
  conn.Open();
  OleDbCommand comm = new OleDbCommand("SELECT name FROM poll WHERE id=" + Session["pid"], conn);
  OleDbDataReader reader = comm.ExecuteReader();
  if (reader.Read()) {
    pname.Text = reader["name"].ToString();
  }
  reader.Close();
  OleDbDataAdapter adapter = new OleDbDataAdapter("SELECT id, name FROM alternative WHERE poll_id=" + Session["pid"], conn);
  DataSet data = new DataSet();
  adapter.Fill(data, "alternative");
  alternatives.DataSource = data.Tables["alternative"].DefaultView;
  alternatives.DataBind();
  conn.Close();
}

void AltEdit(Object o, DataGridCommandEventArgs e) {
  alternatives.EditItemIndex = e.Item.ItemIndex;
  FillAltGrid();
}

void AltUpdate(Object o, DataGridCommandEventArgs e) {
  string sql = "UPDATE alternative ";
  sql += "SET name='" + ((TextBox)e.Item.Cells[1].Controls[0]).Text + "' ";
  sql += "WHERE id=" + alternatives.DataKeys[e.Item.ItemIndex];
  RunSQL(sql);
  alternatives.EditItemIndex = -1;
  FillAltGrid();
}

void AltCancel(Object o, DataGridCommandEventArgs e) {
  alternatives.EditItemIndex = -1;
  FillAltGrid();
}

void AltDelete(Object o, DataGridCommandEventArgs e) {
  string sql = "DELETE FROM alternative ";
  sql += "WHERE id=" + e.CommandArgument;
  RunSQL(sql);
  FillAltGrid();
}

void ShowPollGrid(Object o, EventArgs e) {
  PollPanel.Visible = true;
  AltPanel.Visible = false;
}

void Page_Load() {
  if (Session["pid"] == null) {
    Session["pid"] = 0;
  };
  if (!Page.IsPostBack) {
    FillAltGrid();
    FillPollGrid();
  }
}
</script>
<html>
<head>
<title>SVG Poll Admin Tool</title>
<link href="poll.css" type="text/css" rel="stylesheet" />
</head>
<body>
<form runat="server">
<asp:Panel id="PollPanel" runat="server">
  <p class="heading">Available Polls:</p>
  <asp:DataGrid id="polls" 
    AutoGenerateColumns="False"
    DataKeyField="id"
    OnItemCommand="PollCommand"
    OnEditCommand="PollEdit"
    OnUpdateCommand="PollUpdate"
    OnCancelCommand="PollCancel"
    runat="server">
  <Columns>
    <asp:BoundColumn DataField="id" HeaderText="<b>id</b>" ReadOnly="True" />
    <asp:BoundColumn DataField="name" HeaderText="<b>name</b>" />
    <asp:TemplateColumn HeaderText="<b>status</b>">
      <ItemTemplate>
        <asp:Label Text='<%# DataBinder.Eval(Container.DataItem, "status") %>' runat="server" />
      </ItemTemplate>
      <EditItemTemplate>
        <asp:LinkButton Text='<%# "toggle status to " + ((DataBinder.Eval(Container.DataItem, "status").ToString() == "active") ? "inactive" : "active") %>' 
          CommandName="Toggle" 
          CommandArgument='<%# DataBinder.Eval(Container.DataItem, "status") %>'
          runat="server" />
      </EditItemTemplate>
    </asp:TemplateColumn>
    <asp:EditCommandColumn 
      EditText="Edit"
      UpdateText="Update"
      CancelText="Cancel" />
    <asp:TemplateColumn HeaderText="<b>alternatives</b>">
      <ItemTemplate>
        <asp:LinkButton 
          Text="Add/Remove alternatives" 
          CommandName="Alternatives"
          CommandArgument='<%# DataBinder.Eval(Container.DataItem, "id") %>'
          runat="server" />
      </ItemTemplate>
    </asp:TemplateColumn>
    <asp:TemplateColumn HeaderText="<b>remove</b>">
      <ItemTemplate>
        <asp:LinkButton 
          CommandName="Delete" 
          CommandArgument='<%# DataBinder.Eval(Container.DataItem, "id") %>'
          Text="Delete" 
          runat="server"/>
      </ItemTemplate>
    </asp:TemplateColumn>
  </Columns>
  </asp:DataGrid>
  <p class="heading">Create new poll</p>
  Poll name: 
    <asp:TextBox id="pollname" EnableViewState="False" runat="server" />
    <asp:Button Text="Create!" 
      OnClick="CreatePoll" runat="server" />
</asp:Panel>

<asp:Panel id="AltPanel" runat="server">
  <p><b><asp:Label CssClass="bold" id="pname" runat="server" /></b></p>
  <p class="heading">Alternatives:</p>	
  <asp:DataGrid id="alternatives" 
    AutoGenerateColumns="False"
    DataKeyField="id"
    OnEditCommand="AltEdit"
    OnUpdateCommand="AltUpdate"
    OnCancelCommand="AltCancel"
    OnDeleteCommand="AltDelete"
    runat="server">
    <Columns>
      <asp:BoundColumn DataField="id" HeaderText="id" ReadOnly="True" />
      <asp:BoundColumn DataField="name" HeaderText="name" />
      <asp:EditCommandColumn 
        EditText="Edit"
        UpdateText="Update"
        CancelText="Cancel" />
      <asp:TemplateColumn HeaderText="remove">
        <ItemTemplate>
          <asp:LinkButton 
            CommandName="Delete" 
            CommandArgument='<%# DataBinder.Eval(Container.DataItem, "id") %>'
            Text="Delete" 
            runat="server"/>
        </ItemTemplate>
      </asp:TemplateColumn>
    </Columns>
  </asp:DataGrid>
  <p class="heading">Create new alternative</p>
  Alternative name: 
    <asp:TextBox id="altname" EnableViewState="False" runat="server" />
    <asp:Button Text="Create!" 
      OnClick="CreateAlternative" runat="server" />
   <br /><asp:LinkButton Text="Back" OnClick="ShowPollGrid" runat="server" />
</asp:Panel>
  <p><asp:Label id="message" CssClass="bold" runat="server" /></p>
</form>
</body>
</html>
