

/**
 * Title:        ModifyDOM
 * Description:  Read a DOM from the CAD2SVG translator (Savage Software) and Modify
 * Copyright:    Copyright (c) 2002
 * Company:      MMC
 * @author
 * @version 1.0
 */

  import org.w3c.dom.*;

public class ActivateLayer {

  public ActivateLayer() {
  }

  public Element activate(Element activeLyr) {
    if (activeLyr != null) {
      String id = activeLyr.getAttribute("id");
      String page = id.substring(id.indexOf("-")+1,id.length()-1);
      NodeList nl = activeLyr.getChildNodes();
      for (int i=0;i<nl.getLength();i++) {
         if ((nl.item(i).getNodeType()!=Element.TEXT_NODE) &&
            (nl.item(i).getNodeName().equals("ellipse"))) {
          Element e = (Element)nl.item(i);
          e.setAttribute("onmouseover","over(evt)");
          e.setAttribute("onmouseout","out(evt)");
          e.setAttribute("onclick","click(evt)");
          e.setAttribute("style","fill:yellow;fill-opacity:0.25");
          e.setAttributeNS("http://www.sams.com/2002/SVGUnleashed/ch24/aec","aec:page",page+"b");
        }
        else if ((nl.item(i).getNodeType()!=Element.TEXT_NODE) &&
            (nl.item(i).getNodeName().equals("g"))) {
          Element e = (Element)nl.item(i).getFirstChild().getNextSibling();
          e.setAttribute("onmouseover","over(evt)");
          e.setAttribute("onmouseout","out(evt)");
          e.setAttribute("onclick","click(evt)");
          e.setAttribute("style","fill:yellow;fill-opacity:0.25");
          e.setAttributeNS("http://www.sams.com/2002/SVGUnleashed/ch24/aec","aec:page",page+"b");
        }
      }
    }
    return activeLyr;
  }
}