

/**
 * Title:        ModifyDOM
 * Description:  DXF to SVG for Sams chapter 26
 * Copyright:    Copyright (c) 2002
 * Company:      MMC
 * @author
 * @version 1.0
 */
  import java.io.*;
  import java.math.*;

  public class Point {
    double x;
    double y;

    public Point() {
      x = 0.0;
      y = 0.0;
    }

    public Point(double x, double y) {
      this.x = x;
      this.y = y;
    }

    public void readDXFPoint(BufferedReader in) throws IOException  {
      String line;
      while (((line = in.readLine()) != null) &&
              (!line.equals("  0"))) {
        if (line.equals(" 10"))
          this.x = Double.valueOf(in.readLine()).doubleValue();
        else if (line.equals(" 20")) {
          this.y = -1.0 * Double.valueOf(in.readLine()).doubleValue();
          break;
        }
      }
    }
}