<?php
  header("Content-type: image/svg+xml");
  $colors = array("aqua", 
                  "blue",
                  "fuchsia",
                  "gray",
                  "green",
                  "lime",
                  "maroon",
                  "navy",
                  "olive",
                  "purple",
                  "red",
                  "silver",
                  "teal",
                  "yellow");
  $segments = "";
  $descriptions = "";
  $sname = $HTTP_GET_VARS["pname"];
  $sum = $HTTP_GET_VARS["sum"];
  $cntseg = $HTTP_GET_VARS["cntseg"];
  $angle = 0;  // middle 100 150; radius = 50!
  for ($i=1; $i<=$cntseg; $i++) {
    $color = $colors[($i-1) % count($colors)];
    $vote = $HTTP_GET_VARS["votes" . $i]; 
    $arc = ($vote/$sum >= .5) ? "1,1" : "0,1";
    $x1 = round(100 + 50*cos($angle), 0);
    $y1 = round(150 + 50*sin($angle), 0);
    $angle += 2*Pi() * $vote / $sum;
    $x2 = round(100 + 50*cos($angle), 0);
    $y2 = round(150 + 50*sin($angle), 0);
    if ($vote > 0) {
      $segments .= "<path d=\"M $x1,$y1 A50,50 0 $arc $x2,$y2 L100,150 L$x1,$y1\" style=\"fill:$color;stroke:black;stroke-width:1\" id=\"part$i\" />\n";
    }
    $descriptions .= "<rect id=\"d$i\" x=\"185\" y=\"" . (195 + 10*$i) . "\" width=\"5\" height=\"5\" style=\"fill:$color;stroke:black;stroke-width:1\" />";
    $descriptions .= "<text id=\"d$it\" x=\"195\" y=\"" . (201 + 10*$i) . "\" style=\"font-face:Arial, Geneva, Helvetica, sans-serif;font-size:6pt;font-weight:bold;color:white;alignment-baseline:baseline\">";
    $descriptions .= htmlspecialchars($HTTP_GET_VARS["name" . $i]) ;
    $descriptions .= " (" . round(100*$vote/$sum, 0) . "%)</text>\n";
  }
  $svg = "";
  if ($fh = fopen("torso.svg", "r")) {
    while (!feof($fh)) {
      $svg .= fgets($fh, 1024) . "\n";
    }
  }
  fclose($fh);

  $svg = str_replace("%SEGMENTS%", $segments, $svg);
  $svg = str_replace("%SURVEYNAME%", $sname, $svg);

  $svg = str_replace("%SVGHEIGHT%", 230 + 10*$cntseg, $svg);
  $svg = str_replace("%DESCHEIGHT%", 5 + 10*$cntseg, $svg);
  $svg = str_replace("%DESCRIPTIONS%", $descriptions, $svg);
  echo($svg);
?>