# phpMyAdmin MySQL-Dump
# version 2.2.6-rc2
# http://phpwizard.net/phpMyAdmin/
# http://www.phpmyadmin.net/ (download page)
#
# Host: localhost
# Generation Time: Apr 17, 2002 at 06:42 PM
# Server version: 4.00.01
# PHP Version: 4.2.0RC4
# Database : `svg`
# --------------------------------------------------------

#
# Table structure for table `alternative`
#

DROP TABLE IF EXISTS `alternative`;
CREATE TABLE `alternative` (
  `id` int(11) NOT NULL auto_increment,
  `text` varchar(255) default NULL,
  `question_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

# --------------------------------------------------------

#
# Table structure for table `answer`
#

DROP TABLE IF EXISTS `answer`;
CREATE TABLE `answer` (
  `id` int(11) NOT NULL auto_increment,
  `question_id` int(11) NOT NULL default '0',
  `alternative_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

# --------------------------------------------------------

#
# Table structure for table `person`
#

DROP TABLE IF EXISTS `person`;
CREATE TABLE `person` (
  `id` int(11) NOT NULL auto_increment,
  `email` varchar(50) default NULL,
  `survey_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

# --------------------------------------------------------

#
# Table structure for table `question`
#

DROP TABLE IF EXISTS `question`;
CREATE TABLE `question` (
  `id` int(11) NOT NULL auto_increment,
  `text` varchar(255) NOT NULL default '',
  `type` tinyint(4) NOT NULL default '0',
  `survey_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

# --------------------------------------------------------

#
# Table structure for table `questiontype`
#

DROP TABLE IF EXISTS `questiontype`;
CREATE TABLE `questiontype` (
  `id` tinyint(4) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

#
# Dumping data for table `questiontype`
#

INSERT INTO `questiontype` (`id`, `name`) VALUES (1, 'radio'),
(2, 'checkbox');
# --------------------------------------------------------

#
# Table structure for table `survey`
#

DROP TABLE IF EXISTS `survey`;
CREATE TABLE `survey` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) default NULL,
  `status` enum('active','inactive') NOT NULL default 'inactive',
  `persons` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

