<%@ Page Language="c#" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.OleDb" %>
<%@ Import Namespace="System.IO" %>
<script runat="server">
bool ipcheck = true; // whether to check IP
bool idcheck = true; // whether to check GUID from cookie

void Show_Poll(int poll_id) {
  OleDbConnection conn = new OleDbConnection(
    "Provider=Microsoft.Jet.OleDb.4.0; Data Source=c:\\inetpub\\db\\svg.mdb");
  conn.Open();
  OleDbCommand comm1 = new OleDbCommand("SELECT * FROM poll WHERE id=" + poll_id + " ORDER BY id", conn);
  OleDbDataReader reader1 = comm1.ExecuteReader();
  reader1.Read();
  string pname = reader1["name"].ToString();
  reader1.Close();
  OleDbCommand comm2 = new OleDbCommand("SELECT * FROM alternative WHERE poll_id=" + poll_id + " ORDER BY id", conn);
  OleDbDataReader reader2 = comm2.ExecuteReader();
  string querystring = "";
  int cntalt = 0;
  while (reader2.Read()) {
    cntalt++;
    querystring += "&text" + cntalt + "=" + Server.UrlEncode(reader2["name"].ToString());
    querystring += "&id" + cntalt + "=" + reader2["id"];
  }
  reader2.Close();
  conn.Close();
  querystring = "?cntalt=" + cntalt + querystring;
  querystring += "&pid=" + poll_id;
  querystring += "&IE=.svg";

  PollGrid.InnerHtml = "<embed type=\"image/svg+xml\" width=\"300\" ";
  PollGrid.InnerHtml += "src=\"svg1.aspx" + querystring + "\" ";
  PollGrid.InnerHtml += "height=\"" + (50*(cntalt+1)) + "\"></embed>";
  
  message.Text = pname;
}

void Show_Results() {
  int pid, sum;
  string pname = "";
  OleDbConnection conn = new OleDbConnection(
    "Provider=Microsoft.Jet.OleDb.4.0; Data Source=c:\\inetpub\\db\\svg.mdb");
  conn.Open();
  OleDbCommand comm1 = new OleDbCommand("SELECT id, name FROM poll WHERE status='active'", conn);
  OleDbDataReader reader1 = comm1.ExecuteReader();
  if (reader1.Read()) {
    pid = Convert.ToInt32(reader1["id"]);
    pname = (string)reader1["name"];
    reader1.Close();
    OleDbCommand comm2 = new OleDbCommand("SELECT SUM(votes) FROM alternative WHERE poll_id=" + pid, conn);
    OleDbDataReader reader2 = comm2.ExecuteReader();
    reader2.Read();
    sum = Convert.ToInt32(reader2[0]);
    reader2.Close();
    OleDbCommand comm3 = new OleDbCommand("SELECT DISTINCT name, votes FROM alternative WHERE poll_id=" + pid + " GROUP BY name, votes", conn);
    OleDbDataReader reader3 = comm3.ExecuteReader();
    string querystring = "?pname=" + Server.UrlEncode(pname);
    int cntbars = 0;
    int maxvote = 0, minvote = 0, currentvote;
    while (reader3.Read()) {
      currentvote = Convert.ToInt32(reader3["votes"].ToString());
      if (maxvote == 0) { maxvote = currentvote; minvote = currentvote; }
      if (maxvote < currentvote) { maxvote = currentvote; }
      if (minvote > currentvote) { minvote = currentvote; }
      cntbars++;
      querystring += "&name" + cntbars + "=" + Server.UrlEncode(reader3["name"].ToString());
      querystring += "&votes" + cntbars + "=" + Convert.ToInt32(reader3["votes"].ToString());
    }
    reader3.Close();
    querystring += "&cntbars=" + cntbars;
    querystring += "&sum=" + sum;
    querystring += "&minvote=" + minvote;
    querystring += "&maxvote=" + maxvote;
    querystring += "&IE=.svg";
    PollGrid.InnerHtml = "<embed type=\"image/svg+xml\" width=\"300\" ";
    PollGrid.InnerHtml += "src=\"svg2.aspx" + querystring + "\" ";
    PollGrid.InnerHtml += "height=\"" + (115 + 45*cntbars) + "\"></embed>";
  } else {
    reader1.Close();
    message.Text = "no poll available!";
  }
  conn.Close();
}

void Vote() {
  if (Request.QueryString["alt"]  != null) {
    string poll_id = Request.QueryString["id"];
    string id = Request.QueryString["alt"];
    string ip = Request.ServerVariables["REMOTE_ADDR"];
    string guid = getGUID();
    OleDbConnection conn = new OleDbConnection(
      "Provider=Microsoft.Jet.OleDb.4.0; Data Source=c:\\inetpub\\db\\svg.mdb");
    conn.Open();
    OleDbCommand comm;
    if (ipcheck && idcheck) {
      comm = new OleDbCommand("SELECT * FROM poll, person WHERE (person.ip='" + ip + "' OR person.guid='" + guid + "') AND person.poll_id = poll.id AND poll.id=" + poll_id, conn);
    } else if (ipcheck) {
      comm = new OleDbCommand("SELECT * FROM poll, person WHERE (person.ip='" + ip + "') AND person.poll_id = poll.id AND poll.id=" + poll_id, conn);
    } else if (idcheck) {
      comm = new OleDbCommand("SELECT * FROM poll, person WHERE (person.guid='" + guid + "') AND person.poll_id = poll.id AND poll.id=" + poll_id, conn);
    } else {
      // bogus SELECT 
      comm = new OleDbCommand("SELECT * FROM poll WHERE status='bogus'", conn);
    }
    OleDbDataReader reader = comm.ExecuteReader();
    if (!reader.Read()) {
      reader.Close();
      OleDbCommand comm1 = new OleDbCommand("UPDATE alternative SET votes=votes+1 WHERE poll_id IN (SELECT id FROM poll WHERE status='active') AND id=" + id, conn);
      comm1.ExecuteNonQuery();
      OleDbCommand comm2 = new OleDbCommand("INSERT INTO person (ip, [guid], poll_id) VALUES ('" + ip + "', '" + guid + "', " + poll_id + ")", conn);
      comm2.ExecuteNonQuery();
    } else {
      reader.Close();
    }
    conn.Close();
    message.Text = "Thank you for your vote!";
    Show_Results();
  } 
}

string getGUID() {
  string guid;
  if (Request.Cookies["svgGUID"] != null) {
    guid = Request.Cookies["svgGUID"].Value;
  } else {
    guid = Guid.NewGuid().ToString();
    Response.Cookies["svgGUID"].Value = guid;
    Response.Cookies["svgGUID"].Expires = DateTime.Now.AddDays(30);
  }
  return guid;
}

void Page_Load() {
  if (!Page.IsPostBack && Request.QueryString["alt"] == null) {
    string ip = Request.ServerVariables["REMOTE_ADDR"];
    string guid = getGUID();
    OleDbConnection conn = new OleDbConnection(
      "Provider=Microsoft.Jet.OleDb.4.0; Data Source=c:\\inetpub\\db\\svg.mdb");
    conn.Open();
    OleDbCommand comm;
    if (ipcheck && idcheck) {
      comm = new OleDbCommand("SELECT poll.id FROM poll WHERE poll.status='active' AND id NOT IN (SELECT poll_id FROM person, poll WHERE person.ip='" + ip + "' OR person.guid='" + guid + "')", conn);
    } else if (ipcheck) {
      comm = new OleDbCommand("SELECT poll.id FROM poll WHERE poll.status='active' AND id NOT IN (SELECT poll_id FROM person, poll WHERE person.ip='" + ip + "')", conn);
    } else if (idcheck) {
      comm = new OleDbCommand("SELECT poll.id FROM poll WHERE poll.status='active' AND id NOT IN (SELECT poll_id FROM person, poll WHERE person.guid='" + guid + "')", conn);
    } else {
      comm = new OleDbCommand("SELECT poll.id FROM poll WHERE poll.status='active'", conn);
    }
    OleDbDataReader reader = comm.ExecuteReader();
    if (reader.Read()) {
      Show_Poll(Convert.ToInt32(reader["id"]));
    } else {
      Show_Results();
    }
    reader.Close(); 
    conn.Close();
  } else {
    Vote();
  }
}
</script>
<html>
<head>
<title>SVG Poll</title>
<link href="poll.css" type="text/css" rel="stylesheet" />
</head>
<body>
<form runat="server">
<p><asp:Label id="message" CssClass="heading" runat="server" /></p>
<div id="PollGrid" runat="server" />
</form>
</body>
</html>