<%@ Page Language="c#" Debug="true" %>
<%@ Import Namespace="System.IO" %>
<script runat="server">
void Page_Load() {
  Response.ContentType = "image/svg+xml";
  string a = "";
  int cntalt = Convert.ToInt32(Request.QueryString["cntalt"]);
  string poll_id = Request.QueryString["pid"];
  for (int i=1; i<=cntalt; i++) {
    a += "<text id=\"vote" + i + "\" x=\"50\" y=\"" + (30 + 50*i) + "\" style=\"font-face:Arial, Geneva, Helvetica, sans-serif;font-size:12pt;alignment-baseline:baseline\">";
    a += Server.HtmlEncode(Request.QueryString["text"+i]);
    a += "</text>\n";
    a += "<rect x=\"35\" y=\"" + (5 + 50*i) + "\" width=\"200\" height=\"40\" style=\"fill:none;stroke-width:1;stroke:rgb(204,204,204)\" />\n";
    a += "<circle cx=\"202\" cy=\"" + (27 + 50*i) + "\" r=\"10\" style=\"fill:black;filter:url(#shadow)\" />\n";
    a += "<a xlink:href=\"index.aspx?alt=" + Request.QueryString["id"+i] + "&amp;id=" + poll_id + "\">\n";
    a += "<circle id=\"button" + i + "\" cx=\"200\" cy=\"" + (25 + 50*i) + "\" r=\"10\" style=\"fill:url(#radGrad)\">\n";
    a += "<set attributeName=\"cx\" begin=\"mouseover\" end=\"mouseout\" to=\"202\" />\n";
    a += "<set attributeName=\"cy\" begin=\"mouseover\" end=\"mouseout\" to=\"" + (27 + 50*i) + "\" />  \n";
    a += "</circle></a>\n";
    a += "<g id=\"hook" + i + "\" style=\"visibility:hidden\">\n";
    a += "<path transform=\"translate(0,2)\" d=\"M200 " + (25 + 50*i) + " C200 " + (25 + 50*i) + " 212 " + (32 + 50*i) + " 216 " + (41 + 50*i) + " C216 " + (41 + 50*i) + " 220 " + (15 + 50*i) + " 233 " + (11 + 50*i) + "\"";
    a += " style=\"fill:none;filter:url(#shadow);stroke-width:4;stroke:rgb(100,100,100)\" />\n";
    a += "<path d=\"M200 " + (25 + 50*i) + " C200 " + (25 + 50*i) + " 212 " + (32 + 50*i) + " 216 " + (41 + 50*i) + " C216 " + (41 + 50*i) + " 220 " + (14 + 50*i) + " 233 " + (11 + 50*i) + "\"";
    a += " style=\"fill:none;stroke-width:4;stroke:rgb(100,100,100)\" />\n";
    a += "</g>\n";
  }
  StreamReader sr = new StreamReader(Server.MapPath("torso1.svg"));
  string svg = sr.ReadToEnd();
  sr.Close();

  svg = svg.Replace("%SVGHEIGHT%", (50*(cntalt+1)).ToString());
  svg = svg.Replace("%CNTALT%", cntalt.ToString());
  svg = svg.Replace("%ALTERNATIVES%", a);
  Response.Write(svg);
} 
</script>