

/**
 * Title:        ModifyDOM
 * Description:  Read a DOM from the CAD2SVG translator (Savage Software) and Modify
 * Copyright:    Copyright (c) 2002
 * Company:      MMC
 * @author
 * @version 1.0
 */

import java.io.*;

public class DirFilter implements FilenameFilter {
  String filterStr;

  public DirFilter(String filterStr) {
    this.filterStr = filterStr;
  }

  public boolean accept(File dir, String name) {
    String file = new File(name).getName();
    return file.indexOf(filterStr) != -1;

  }
}