

/**
 * Title:        dataQuery
 * Description:  servlet to query data from  MySql datasource using Jaxp
 * Copyright:    Copyright (c) 2001
 * Company:      MMC
 * @author Randy George
 * @version 1.0
 */

  import java.io.*;
  import org.xml.sax.*;

    class SVGErrorHandler implements ErrorHandler {
      private PrintWriter out;

      public SVGErrorHandler(PrintWriter out) {
        this.out = out;
     }

    public void warning(SAXParseException exception) throws SAXException {



      out.println("**Parsing Warning**\n" +
                         "  Line:    " +
                           exception.getLineNumber() + "\n" +
                         "   URI      " +
                           exception.getSystemId() + "\n" +
                         "   Message   " +
                           exception.getMessage());
      throw new SAXException("Warning encountered");
    }

     public void error(SAXParseException exception) throws SAXException {
      out.println("**Parsing Error**\n" +
                         "  Line:    " +
                           exception.getLineNumber() + "\n" +
                         "   URI      " +
                           exception.getSystemId() + "\n" +
                         "   Message   " +
                           exception.getMessage());
      throw new SAXException("Error encountered");
    }

    public void fatalError(SAXParseException exception) throws SAXException {
      out.println("**Parsing Fatal Error**\n" +
                         "  Line:    " +
                           exception.getLineNumber() + "\n" +
                         "   URI      " +
                           exception.getSystemId() + "\n" +
                         "   Message   " +
                           exception.getMessage());
      throw new SAXException("Fatal Error encountered");
    }

  }

