  var dataWin;
  var label = "";
  var style;
  var offset = 0.01;

  // must be calculated from viewbox to w x h
  var x0 = 0;
  var y0 = 0;
  var vboxW = 0;
  var vboxH = 0;
  var svgW = 0;
  var svgH = 0;

  function on_load(e){
    svgdoc = evt.target.getOwnerDocument();
    svgroot = svgdoc.getDocumentElement();

    //initialize cursor parameters
    var vbox = (svgroot.getAttribute("viewBox")).split(' ');
    x0 = parseFloat(vbox[0]);
    y0 = parseFloat(vbox[1]);
    vboxW = parseFloat(vbox[2]);
    vboxH = parseFloat(vbox[3]);
    svgW = parseFloat(svgroot.getAttribute("width"));
    svgH = parseFloat(svgroot.getAttribute("height"));

     // initialize label text
    var data = svgdoc.createTextNode("");
    var text = svgdoc.createElement("text");
    text.setAttribute("transform","translate("+ x0 + "," + (y0+0.1) + ")");
    text.setAttribute("style", "stroke:black;stroke-width:0.001;fill:black;font-size:0.025;font-family:arial;");
    text.setAttribute("id", "label");
    text.appendChild(data);
    svgroot.appendChild(text);
    //alert(printNode(text));
  }

  function DoOnMouseMove(e) {
    var X = x0 + (e.clientX - svgroot.currentTranslate.x)*(vboxW/(svgW*svgroot.currentScale));
    var Y = y0 - offset + (e.clientY - svgroot.currentTranslate.y)*(vboxH/(svgH*svgroot.currentScale));
    label =  svgdoc.getElementById("label");
    label.setAttribute("transform","translate("+ X + "," + Y + ")");
  }

  // mouse_over
  function over(e) {
    var id = e.currentTarget.id;
    if (id!="") {
      //rollover label on
      label =  svgdoc.getElementById("label");
      label.firstChild.setData(id);

      var svgstyle = e.currentTarget.style;
      style = svgstyle.getPropertyValue('fill');
      svgstyle.setProperty ('fill','yellow');
    }
  }

  //mouse_out
  function out(e) {
    //rollover label off
    var label =  svgdoc.getElementById("label");
    label.getFirstChild().setData(" ");

    var svgstyle = e.getCurrentTarget().getStyle();
    svgstyle.setProperty ('fill',style);      
  }


  //mouse click
  function click(e) {
    if (e.getButton()==0) {
      if (dataWin!=null) dataWin.close();
      if (e.getShiftKey()==1) {
      dataWin=window.open("/DataQuery1/servlet/dataQuery1?table="+ e.currentTarget.parentNode.id + "&id=" + e.currentTarget.id + "&chart=false","dataWindow","width=400,height=300,left=500,top=0,scrollbars=yes,toolbar=yes, location=yes, menubar=yes,resizable=yes,status=yes");
      }
      else {
      dataWin=window.open("/DataQuery1/servlet/dataQuery1?table="+ e.currentTarget.parentNode.id + "&id=" + e.currentTarget.id + "&chart=true","dataWindow","width=400,height=300,left=500,top=0,scrollbars=yes,toolbar=yes, location=yes, menubar=yes,resizable=yes,status=yes");
      }
      dataWin.focus();
    }
  }