  var svgdoc;
  var svgroot;
  var dataWin;

// note: set this to the servlet path for your server
  var servlet_path = "/servlet/";

  var label = "";
  var style;
  var offset = 0.0;;

  // must be calculated from viewbox to w x h
  var x0 = 0;
  var y0 = 0;
  var vboxW = 0;
  var vboxH = 0;
  var svgW = 0;
  var svgH = 0;
  var sz = 0.25;
  var zoom = 1.0;

  function on_load(evt){
    svgdoc = evt.target.getOwnerDocument();
    svgroot = svgdoc.getDocumentElement();

    //initialize cursor parameters
    var vbox = (svgroot.getAttribute("viewBox")).split(' ');
    x0 = parseFloat(vbox[0]);
    y0 = parseFloat(vbox[1]);
    vboxW = parseFloat(vbox[2]);
    vboxH = parseFloat(vbox[3]);
    svgW = parseFloat(svgroot.getAttribute("width"));
    svgH = parseFloat(svgroot.getAttribute("height"));
    if (vboxW>vboxH) sz = (vboxW/30.0);
    else sz = vboxW/30.0;
    offset = sz ;

    // initialize label text
    var data = svgdoc.createTextNode("Testing");
    var text = svgdoc.createElement("text");
    text.setAttribute("transform","translate("+ x0 + "," + y0 + ") scale(" + 1.0/zoom + ")");
    text.setAttribute("style", "stroke:white;stroke-width:0.0001;fill:white;font-size:"+sz+";font-family:arial;");
    text.setAttribute("id", "label");
    text.appendChild(data);
    svgroot.appendChild(text);
    //alert(printNode(text));
  }

  function onZoom() {
    zoom = svgroot.currentScale;
  }

  function mousemove(evt) {
    var X = x0 + (evt.clientX - svgroot.currentTranslate.x)*(vboxW/(svgW*svgroot.currentScale));
        var Y = y0 - offset + (evt.clientY - svgroot.currentTranslate.y)*(vboxH/(svgH*svgroot.currentScale));
    label =  svgdoc.getElementById("label");
    label.setAttribute("transform","translate("+ X + "," + Y + ") scale(" + 1.0/zoom + ")");
  }

  // mouse over
  function over(evt) {
     var link = evt.currentTarget.getAttributeNS
         ('http://www.sams.com/2002/SVGUnleashed/ch26/fms','link');
    if (link!="") {
      //rollover label on
      label = svgdoc.getElementById("label");
      label.firstChild.setData(link);
      var svgstyle = evt.currentTarget.style;
      svgstyle.setProperty('fill-opacity',0.25);
    }
  }

  //mouse out
  function out(evt) {
    //rollover label off
    var label = svgdoc.getElementById("label");
    label.firstChild.setData(" ");
    var svgstyle = evt.currentTarget.style;
    svgstyle.setProperty('fill-opacity',0.0);  
  }


  //mouse click
  function click(evt) {
    if (evt.getButton()==0) {
      var link = evt.currentTarget.getAttributeNS
         ('http://www.sams.com/2002/SVGUnleashed/ch26/fms','link');
      if (link=="Floor2-N") window.location.href = "1.3a.svg";
      else if (link.indexOf("Floor")!=-1) alert("Only Floor 2 North is active");
      else if (link.indexOf("zone")!=-1) {
       link = link.substring(link.indexOf("zone")+4,link.length);
       if (dataWin!=null) dataWin.close();
         dataWin=window.open(servlet_path+"FMSGraph?cmd=initialize&zone="+link,"dataWin",
    "width=600,height=300,left=200,top=0,scrollbars=yes,toolbar=yes, location=yes,menubar=yes,resizable=yes,status=yes");
        dataWin.focus();
      }
    }
  }